3 ################################################################################
5 # The MIT License (MIT)
7 # Copyright (c) 2016 Stéphane Desneux <sdx@iot.bzh>
8 # (c) 2016 Jan-Simon Möller <jsmoeller@linuxfoundation.org>
10 # Permission is hereby granted, free of charge, to any person obtaining a copy
11 # of this software and associated documentation files (the "Software"), to deal
12 # in the Software without restriction, including without limitation the rights
13 # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
14 # copies of the Software, and to permit persons to whom the Software is
15 # furnished to do so, subject to the following conditions:
17 # The above copyright notice and this permission notice shall be included in
18 # all copies or substantial portions of the Software.
20 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
21 # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
22 # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
23 # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
24 # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
25 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
28 ################################################################################
30 # this script shouldn't be called directly, but through aglsetup.sh that will in
31 # turn execute (source) generated instructions back in the parent shell,
32 # whether it's bash, zsh, or any other supported shell
35 DEFAULT_MACHINE=qemux86-64
36 DEFAULT_BUILDDIR=./build
40 #SCRIPT=$(basename $BASH_SOURCE)
42 SCRIPTDIR=$(cd $(dirname $BASH_SOURCE) && pwd -P)
43 METADIR=$(cd $(dirname $BASH_SOURCE)/../.. && pwd -P)
45 function info() { echo "$@" >&2; }
46 function infon() { echo -n "$@" >&2; }
47 function error() { echo "ERROR: $@" >&2; return 1; }
48 function verbose() { [[ $VERBOSE == 1 ]] && echo "$@" >&2; return 0; }
49 function debug() { [[ $DEBUG == 1 ]] && echo "DEBUG: $@" >&2; return 0;}
51 info "------------ $SCRIPT: Starting"
53 #compute AGL_REPOSITORIES
54 AGL_REPOSITORIES=$(for x in $(ls -d $METADIR/*/templates/{machine,feature}); do echo $(basename $(dirname $(dirname $x))); done | sort -u)
56 function list_machines() {
58 for y in $(ls -d $METADIR/$x/templates/machine/* 2>/dev/null); do
64 function list_all_machines() {
65 for x in $AGL_REPOSITORIES; do
70 function validate_machines() {
71 list_all_machines | sort | uniq -c | while read cnt machine; do
72 [[ $cnt == 1 ]] && continue
73 info "Machine $machine found in the following repositories:"
74 for x in $(ls -d $METADIR/*/templates/machine/$machine); do
77 error "Multiple machine templates are not allowed"
79 debug "Machines list has no duplicate."
82 function list_features() {
84 for y in $(ls -d $METADIR/$x/templates/feature/* 2>/dev/null); do
90 function list_all_features() {
91 for x in $AGL_REPOSITORIES; do
96 function validate_features() {
97 list_all_features | sort | uniq -c | while read cnt feature; do
98 [[ $cnt == 1 ]] && continue;
99 info "Feature $feature found in the following repositories:"
100 for x in $(ls -d $METADIR/*/templates/feature/$feature); do
103 error "Multiple feature templates are not allowed"
105 debug "Features list has no duplicate."
108 function find_machine_dir() {
110 for x in $AGL_REPOSITORIES; do
111 dir=$METADIR/$x/templates/machine/$machine
112 [[ -d $dir ]] && { echo $dir; return 0; }
117 function find_feature_dir() {
119 for x in $AGL_REPOSITORIES; do
120 dir=$METADIR/$x/templates/feature/$feature
121 [[ -d $dir ]] && { echo $dir; return 0; }
128 Usage: . $SCRIPT [options] [feature [feature [... ]]]
131 Compatibility: bash, zsh, ksh
134 -m|--machine <machine>
136 default: '$DEFAULT_MACHINE'
137 -b|--build <directory>
138 build directory to use
139 default: '$DEFAULT_BUILDDIR'
140 -s|--script <filename>
141 file where setup script is generated
142 default: none (no script)
144 flag to force overwriting any existing configuration
158 echo "Available machines:" >&2
159 for x in $AGL_REPOSITORIES; do
160 buf=$(list_machines $x)
161 [[ -z "$buf" ]] && continue
164 [[ $y == $DEFAULT_MACHINE ]] && def="* " || def=" "
170 echo "Available features:" >&2
171 for x in $AGL_REPOSITORIES; do
172 buf=$(list_features $x)
173 [[ -z "$buf" ]] && continue
175 for feature in $buf; do
176 print_feature="$feature"
177 featuredir=$(find_feature_dir $feature)
178 if [ -e $featuredir/included.dep ];then
179 print_feature="$print_feature :($(find_feature_dependency $feature $feature))"
181 echo " $print_feature"
187 function append_fragment() {
188 basefile=$1; shift # output file
189 f=$1; shift # input file
192 debug "adding fragment to $basefile: $f"
194 echo "# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #" >>$basefile
195 echo "# fragment { " >>$basefile
196 [[ -f $f ]] && echo "# $f" >>$basefile || true
198 [[ -n "$label" ]] && echo "$label" >>$basefile
199 [[ -f $f ]] && cat $f >>$basefile || true
201 echo "# }" >>$basefile
202 echo "# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #" >>$basefile
203 [[ -f $f ]] && echo $f >>$BUILDDIR/conf/fragments.log || true
206 function execute_setup() {
208 debug "Executing script $script"
210 [[ $DEBUG == 1 ]] && opts="$opts -x"
211 pushd $BUILDDIR &>/dev/null
212 $BASH $opts $script \
214 || { rc=$?; error "Script $script failed"; }
220 # process all fragments
221 FRAGMENTS_BBLAYERS=""
222 FRAGMENTS_LOCALCONF=""
224 function process_fragments() {
226 debug "processing fragments in dir $dir"
228 verbose " Searching fragments: $dir"
230 # lookup for files with priorities specified: something like xx_bblayers.conf.yyyyy.inc
231 for x in $(ls $dir/??[._]bblayers.conf*.inc 2>/dev/null); do
232 FRAGMENTS_BBLAYERS="$FRAGMENTS_BBLAYERS $(basename $x):$x"
233 verbose " priority $(basename $x | cut -c1-2): $(basename $x)"
236 # same for local.conf
237 for x in $(ls $dir/??[._]local.conf*.inc 2>/dev/null); do
238 FRAGMENTS_LOCALCONF="$FRAGMENTS_LOCALCONF $(basename $x):$x"
239 verbose " priority $(basename $x | cut -c1-2): $(basename $x)"
243 for x in $(ls $dir/??[._]setup*.sh 2>/dev/null); do
244 FRAGMENTS_SETUP="$FRAGMENTS_SETUP $(basename $x):$x"
245 verbose " priority $(basename $x | cut -c1-2): $(basename $x)"
250 function containsFeature () {
251 for feature in $1; do
252 [[ "$feature" == "$2" ]] && return 1;
257 function find_feature_dependency() {
259 featuredir=$(find_feature_dir $1)
261 if [ -e $featuredir/included.dep ]; then
262 dep_features="$(cat $featuredir/included.dep)"
263 for dep_feature in $dep_features; do
264 full_feature="$full_feature $res_dep_features"
265 res_dep_features="$res_dep_features $dep_feature"
266 if containsFeature $dep_feature $full_feature ; then
267 res_dep_features="$res_dep_features $(find_feature_dependency $dep_feature $full_feature)"
271 echo "$res_dep_features";
276 debug "Parsing arguments: $@"
277 TEMP=$(getopt -o m:b:s:fvdh --long machine:,builddir:,script:,force,verbose,debug,help -n $SCRIPT -- "$@")
278 [[ $? != 0 ]] && { usage; exit 1; }
283 ### default options values
284 MACHINE=$DEFAULT_MACHINE
285 BUILDDIR=$DEFAULT_BUILDDIR
291 -m|--machine) MACHINE=$2; shift 2;;
292 -b|--builddir) BUILDDIR=$2; shift 2;;
293 -s|--setupscript) SETUPSCRIPT=$2; shift 2;;
294 -f|--force) FORCE=1; shift;;
295 -v|--verbose) VERBOSE=1; shift;;
296 -d|--debug) VERBOSE=1; DEBUG=1; shift;;
297 -h|--help) HELP=1; shift;;
299 *) error "Arguments parsing error"; exit 1;;
303 [[ "$HELP" == 1 ]] && { usage; exit 0; }
305 verbose "Command line arguments: ${GLOBAL_ARGS[@]}"
307 # the remaining args are the features
310 # validate the machine list
311 debug "validating machines list"
314 # validate the machine
315 debug "validating machine $MACHINE"
316 find_machine_dir $MACHINE >/dev/null || error "Machine '$MACHINE' not found in [ $(list_all_machines)]"
318 # validate the features list
319 debug "validating features list"
323 for FEATURE in $FEATURES;do
324 TMP_FEATURES="$TMP_FEATURES $FEATURE"
325 TMP_FEATURES="$TMP_FEATURES $(find_feature_dependency $FEATURE $TMP_FEATURES)"
327 FEATURES=$TMP_FEATURES
328 echo "Features used: $FEATURES"
330 # validate the features
331 for f in $FEATURES; do
332 debug "validating feature $f"
333 find_feature_dir $f >/dev/null || error "Feature '$f' not found in [ $(list_all_features)]"
337 debug "validating builddir $BUILDDIR"
338 BUILDDIR=$(mkdir -p $BUILDDIR && cd $BUILDDIR && pwd -P)
340 ###########################################################################################
341 function dump_log() {
342 info " ------------ $(basename $1) -----------------"
344 info " ----------------------------------------"
347 function genconfig() {
348 info "Generating configuration files:"
349 info " Build dir: $BUILDDIR"
350 info " Machine: $MACHINE"
351 info " Features: $FEATURES"
353 # step 1: run usual OE setup to generate conf dir
354 export TEMPLATECONF=$(cd $SCRIPTDIR/../templates/base && pwd -P)
355 debug "running oe-init-build-env with TEMPLATECONF=$TEMPLATECONF"
356 info " Running $METADIR/poky/oe-init-build-env"
357 info " Templates dir: $TEMPLATECONF"
360 . $METADIR/poky/oe-init-build-env $BUILDDIR >/dev/null
363 # step 2: concatenate other remaining fragments coming from base
364 process_fragments $TEMPLATECONF
366 # step 3: fragments for machine
367 process_fragments $(find_machine_dir $MACHINE)
369 # step 4: fragments for features
370 for feature in $FEATURES; do
371 process_fragments $(find_feature_dir $feature)
374 # step 5: sort fragments and append them in destination files
375 FRAGMENTS_BBLAYERS=$(sed 's/ /\n/g' <<<$FRAGMENTS_BBLAYERS | sort)
376 debug "bblayer fragments: $FRAGMENTS_BBLAYERS"
377 info " Config: $BUILDDIR/conf/bblayers.conf"
378 for x in $FRAGMENTS_BBLAYERS; do
380 append_fragment $BUILDDIR/conf/bblayers.conf $file
384 FRAGMENTS_LOCALCONF=$(sed 's/ /\n/g' <<<$FRAGMENTS_LOCALCONF | sort)
385 debug "localconf fragments: $FRAGMENTS_LOCALCONF"
386 info " Config: $BUILDDIR/conf/local.conf"
387 for x in $FRAGMENTS_LOCALCONF; do
389 append_fragment $BUILDDIR/conf/local.conf $file
393 FRAGMENTS_SETUP=$(sed 's/ /\n/g' <<<$FRAGMENTS_SETUP | sort)
394 debug "setup fragments: $FRAGMENTS_SETUP"
395 cat <<EOF >$BUILDDIR/conf/setup.sh
398 # this script has been generated by $BASH_SOURCE
400 export MACHINE="$MACHINE"
401 export FEATURES="$FEATURES"
402 export BUILDDIR="$BUILDDIR"
403 export METADIR="$METADIR"
405 echo "--- beginning of setup script"
407 info " Setup script: $BUILDDIR/conf/setup.sh"
408 for x in $FRAGMENTS_SETUP; do
410 append_fragment $BUILDDIR/conf/setup.sh $file "echo '--- fragment $file'"
413 append_fragment $BUILDDIR/conf/setup.sh "" "echo '--- end of setup script'"
415 infon " Executing setup script ... "
416 execute_setup $BUILDDIR/conf/setup.sh 2>&1 | tee $BUILDDIR/conf/setup.log
417 [[ ${PIPESTATUS[0]} == 0 ]] && {
419 [[ $VERBOSE == 1 ]] && dump_log $BUILDDIR/conf/setup.log
420 rm $BUILDDIR/conf/setup.sh
423 info "FAIL: please check $BUILDDIR/conf/setup.log"
424 dump_log $BUILDDIR/conf/setup.log
427 # NOTE: the setup.sh script is removed if execution succeeded (only the log remains)
430 ###########################################################################################
432 # check for overwrite
433 [[ $FORCE -eq 1 ]] && rm -f \
434 $BUILDDIR/conf/local.conf \
435 $BUILDDIR/conf/bblayers.conf \
436 $BUILDDIR/conf/setup.* \
439 if [[ -f $BUILDDIR/conf/local.conf || -f $BUILDDIR/conf/bblayers.conf ]]; then
440 info "Configuration files already exist:"
441 for x in $BUILDDIR/conf/local.conf $BUILDDIR/conf/bblayers.conf; do
442 [[ -f $x ]] && info " - $x"
444 info "Skipping configuration files generation."
445 info "Use option -f|--force to overwrite existing configuration."
450 # always generate setup script in builddir: it can be sourced later manually without re-running the setup
451 infon "Generating setup file: $BUILDDIR/agl-init-build-env ... "
452 cat <<EOF >$BUILDDIR/agl-init-build-env
453 . $METADIR/poky/oe-init-build-env $BUILDDIR
454 if [ -n "\$DL_DIR" ]; then
455 BB_ENV_EXTRAWHITE="\$BB_ENV_EXTRAWHITE DL_DIR"
457 if [ -n "\$SSTATE_DIR" ]; then
458 BB_ENV_EXTRAWHITE="\$BB_ENV_EXTRAWHITE SSTATE_DIR"
460 export BB_ENV_EXTRAWHITE
465 # finally, generate output script if requested by caller
466 if [[ -n "$SETUPSCRIPT" ]]; then
467 debug "generating setupscript in $SETUPSCRIPT"
468 cat <<EOF >$SETUPSCRIPT
469 . $BUILDDIR/agl-init-build-env
473 info "------------ $SCRIPT: Done"